// EkDocList.cpp : implementation file
//

#include "stdafx.h"

#include "EkDocList.h"

///////////////////////////////////////////////////////////
// CEkDocList implementation

CEkDocList::CEkDocList()
{
	CWinApp* pApp = AfxGetApp();
	ASSERT_VALID( pApp );

	// 1 - Iterate through the application's document
	// templates list
	POSITION posTemplate =
				   pApp->GetFirstDocTemplatePosition();
	while( posTemplate != NULL )
	{
		// 2 - For each document template object...
		CDocTemplate* pTemplate =
				pApp->GetNextDocTemplate( posTemplate );
		ASSERT_VALID( pTemplate );
		ASSERT_KINDOF( CDocTemplate, pTemplate );

		// 3 - Iterate through the template's document list
		POSITION posDocument =
				   pTemplate->GetFirstDocPosition();
		while( posDocument != NULL )
		{
			// 4 - For each document object...
			CDocument* pDoc =
					pTemplate->GetNextDoc( posDocument );
			ASSERT_VALID( pDoc );
			ASSERT_KINDOF( CDocument, pDoc );

			// 5 - Add the document pointer to our
			// internal list
			m_DocList.AddTail( pDoc );
		}
	}

	// 6 - Initialize our POSITION member
	m_posDocList = m_DocList.GetHeadPosition();
}

CEkDocList::~CEkDocList()
{
	m_DocList.RemoveAll();
	m_posDocList = NULL;
}

CDocument* CEkDocList::GetNextDoc()
{
	if( m_posDocList == NULL )
		return NULL;

	CDocument* pDoc = m_DocList.GetNext( m_posDocList );
	ASSERT_VALID( pDoc );
	ASSERT_KINDOF( CDocument, pDoc );

	return pDoc;
}