// EkDocList.h : header file
//

#ifndef __EKDOCLIST_H__
#define __EKDOCLIST_H__

#include <afxtempl.h>	// For CTypedPtrList template

///////////////////////////////////////////////////////////
// CEkDocList : enumerator class for the document objects
//            in an MDI application

class CEkDocList
{
public:
	// Constuction - Destruction
	CEkDocList();	// The constructor fills our internal
					// list of pointer to document objects

	~CEkDocList();

	// Operations
	CDocument* GetNextDoc();  // Gets next document object

	// Forbid copy and assignment of CEkDocList objects
private:
	CEkDocList( const CEkDocList& );
	const CEkDocList& operator = ( const CEkDocList& );

private:
	// Implementation

	// Internal list of pointers to document objects
	CTypedPtrList< CObList, CDocument* > m_DocList;

	// Current position in the above list
	POSITION m_posDocList;
};

#endif   // __EKDOCLIST_H__
