// CountView.cpp : implementation of the CCountView class
//

#include "stdafx.h"
#include "DontCloseView.h"

#include "CountDoc.h"
#include "CountView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCountView

IMPLEMENT_DYNCREATE(CCountView, CView)

BEGIN_MESSAGE_MAP(CCountView, CView)
	//{{AFX_MSG_MAP(CCountView)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_CLOSE_FRAME, OnCloseFrame)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCountView construction/destruction

CCountView::CCountView()
{
	// TODO: add construction code here
}

CCountView::~CCountView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CCountView drawing

void CCountView::OnDraw(CDC* pDC)
{
	CCountDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CRect rect;
	GetClientRect( &rect );
	pDC->SetTextAlign( TA_CENTER | TA_BASELINE );

	CString s;
	s.Format( "Counter = %d", pDoc->m_nCount );
	pDC->TextOut( rect.right / 2, 30, s );
	pDC->TextOut( rect.right / 2, 60,
			"Click with left or right button" );
}

/////////////////////////////////////////////////////////////////////////////
// CCountView diagnostics

#ifdef _DEBUG
void CCountView::AssertValid() const
{
	CView::AssertValid();
}

void CCountView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CCountDoc* CCountView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCountDoc)));
	return (CCountDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCountView message handlers

void CCountView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	GetDocument()->OnCountIncrement();

	CView::OnLButtonDown(nFlags, point);
}

void CCountView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	GetDocument()->OnCountDecrement();

	CView::OnRButtonDown(nFlags, point);
}

void CCountView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	// Disable the parent frame window's "Close" system menu
	// command

	CMenu* pMenu = GetParentFrame()->GetSystemMenu( FALSE );
	pMenu->EnableMenuItem( SC_CLOSE, MF_BYCOMMAND | MF_GRAYED );
}

void CCountView::OnCloseFrame() 
{
	GetParentFrame()->PostMessage( WM_CLOSE );
}
