// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "DrawMdiBackground.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_MDIBACK_NORMAL, OnMdibackNormal)
	ON_COMMAND(ID_MDIBACK_CUSTOM, OnMdibackCustom)
	ON_COMMAND(ID_MDIBACK_BITMAP, OnMdibackBitmap)
	ON_UPDATE_COMMAND_UI(ID_MDIBACK_NORMAL, OnUpdateMdibackNormal)
	ON_UPDATE_COMMAND_UI(ID_MDIBACK_CUSTOM, OnUpdateMdibackCustom)
	ON_UPDATE_COMMAND_UI(ID_MDIBACK_BITMAP, OnUpdateMdibackBitmap)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_MdiBackStyle = NORMAL;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create standard toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndTBdemo.Create(this, WS_CHILD | WS_VISIBLE | CBRS_TOP, IDR_DEMO_TOOLBAR) ||
		!m_wndTBdemo.LoadToolBar(IDR_DEMO_TOOLBAR))
	{
		TRACE0("Failed to create demo toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// Mainframe docking
	EnableDocking(CBRS_ALIGN_ANY);

	// Standard toolbar docking
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
					CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	// Demo toolbar docking
	m_wndTBdemo.SetBarStyle(m_wndTBdemo.GetBarStyle() |
					CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	m_wndTBdemo.EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndTBdemo, AFX_IDW_DOCKBAR_LEFT);

	// Subclass MDI Client window
	ASSERT( m_hWndMDIClient != NULL );
	if( !m_wndMdiBackground.SubclassWindow( m_hWndMDIClient ) )
	{
		return -1;
	}

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnMdibackNormal() 
{
	m_MdiBackStyle = NORMAL;
	m_wndMdiBackground.Invalidate( TRUE );
}

void CMainFrame::OnMdibackCustom() 
{
	m_MdiBackStyle = CUSTOM;
	m_wndMdiBackground.Invalidate( TRUE );
}

void CMainFrame::OnMdibackBitmap() 
{
	m_MdiBackStyle = BITMAP;
	m_wndMdiBackground.Invalidate( TRUE );
}

void CMainFrame::OnUpdateMdibackNormal(CCmdUI* pCmdUI) 
{
	pCmdUI->SetRadio( m_MdiBackStyle == NORMAL );
}

void CMainFrame::OnUpdateMdibackCustom(CCmdUI* pCmdUI) 
{
	pCmdUI->SetRadio( m_MdiBackStyle == CUSTOM );
}

void CMainFrame::OnUpdateMdibackBitmap(CCmdUI* pCmdUI) 
{
	pCmdUI->SetRadio( m_MdiBackStyle == BITMAP );
}
