// DrawDoc.cpp : implementation of the CDrawDoc class
//

#include "stdafx.h"
#include "DynamicIcon.h"

#include "DrawDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc

IMPLEMENT_DYNCREATE(CDrawDoc, CDocument)

BEGIN_MESSAGE_MAP(CDrawDoc, CDocument)
	//{{AFX_MSG_MAP(CDrawDoc)
	ON_COMMAND(ID_DRAW_SQUARE, OnDrawSquare)
	ON_COMMAND(ID_DRAW_CIRCLE, OnDrawCircle)
	ON_UPDATE_COMMAND_UI(ID_DRAW_SQUARE, OnUpdateDrawSquare)
	ON_UPDATE_COMMAND_UI(ID_DRAW_CIRCLE, OnUpdateDrawCircle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc construction/destruction

CDrawDoc::CDrawDoc()
{
	m_point = CPoint( 30, 30 );
	m_shape = SQUARE;

	m_hIconSquare = AfxGetApp()->LoadIcon( IDI_SQUARE );
	ASSERT( m_hIconSquare != NULL );

	m_hIconCircle = AfxGetApp()->LoadIcon( IDI_CIRCLE );
	ASSERT( m_hIconCircle != NULL );
}

CDrawDoc::~CDrawDoc()
{
}

BOOL CDrawDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc serialization

void CDrawDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar << m_point << (DWORD) m_shape;
	}
	else
	{
		ar >> m_point >> (DWORD&) m_shape;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc diagnostics

#ifdef _DEBUG
void CDrawDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDrawDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc commands

void CDrawDoc::OnDrawSquare() 
{
	m_shape = SQUARE;
	UpdateAllViews( NULL );
	SetModifiedFlag( TRUE );
}

void CDrawDoc::OnDrawCircle() 
{
	m_shape = CIRCLE;
	UpdateAllViews( NULL );
	SetModifiedFlag( TRUE );
}

void CDrawDoc::OnUpdateDrawSquare(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_shape == SQUARE );
	
	SetFrameIcon();
}

void CDrawDoc::OnUpdateDrawCircle(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_shape == CIRCLE );

	SetFrameIcon();
}

void CDrawDoc::SetFrameIcon()
{
	HICON hIcon = NULL;

	// 1 - Select the correct icon based on the state
	// of the application
	switch( m_shape )
	{
		default:
			ASSERT( FALSE );
			break;

		case CIRCLE:
			hIcon = m_hIconCircle;
			break;

		case SQUARE:
			hIcon = m_hIconSquare;
			break;
	}

	ASSERT( hIcon != NULL );

	CWnd* pFrame = AfxGetMainWnd();
	ASSERT_VALID( pFrame );

	// 2 - Retrieve the current icon
	HICON hCurrentIcon = (HICON) ::GetClassLong( pFrame->GetSafeHwnd(), GCL_HICON );

	// 3 - Only change the icon if needed (avoid flicker)
	if( hCurrentIcon != hIcon )
	{
		::SetClassLong( pFrame->GetSafeHwnd(), GCL_HICON, (long) hIcon );
		pFrame->RedrawWindow( NULL, NULL, RDW_FRAME | RDW_INVALIDATE );
	}
}
