// MdiBackground.cpp : implementation file
//

#include "stdafx.h"
#include "limitposition.h"
#include "MdiBackground.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMdiBackground

CMdiBackground::CMdiBackground()
{
}

CMdiBackground::~CMdiBackground()
{
}


BEGIN_MESSAGE_MAP(CMdiBackground, CWnd)
	//{{AFX_MSG_MAP(CMdiBackground)
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMdiBackground message handlers

BOOL CMdiBackground::OnEraseBkgnd(CDC* pDC) 
{
	// Draw standard MDI background first
	CWnd::OnEraseBkgnd( pDC );

	// The following constants define our position constraints
	// (same values as defined in the CChildFrame class)

	const int LEFT_MIN = 20;
	const int LEFT_MAX = 220;

	const int TOP_MIN = 50;
	const int TOP_MAX = 100;

	const int RIGHT_MIN = 300;
	const int RIGHT_MAX = 500;

	const int BOTTOM_MIN = 250;
	const int BOTTOM_MAX = 300;

	// Draw outermost limits in green
	CBrush brGreen( RGB( 0, 255, 0 ) );
	CBrush* pOldBrush = pDC->SelectObject( &brGreen );
	pDC->PatBlt( LEFT_MIN, TOP_MIN, RIGHT_MAX - LEFT_MIN, BOTTOM_MAX - TOP_MIN, PATCOPY );
	
	// Draw innermost limits in red
	CBrush brRed( RGB( 255, 0, 0 ) );
	pDC->SelectObject( &brRed );
	pDC->PatBlt( LEFT_MAX, TOP_MAX, RIGHT_MIN - LEFT_MAX, BOTTOM_MIN - TOP_MAX, PATCOPY );

	// Draw additional red lines to show innermost limits
	CPen penRed( PS_SOLID, 3, RGB( 255, 0, 0 ) );
	CPen* pOldPen = pDC->SelectObject( &penRed );

	pDC->MoveTo( LEFT_MIN, TOP_MAX );
	pDC->LineTo( RIGHT_MAX, TOP_MAX );

	pDC->MoveTo( LEFT_MIN, BOTTOM_MIN );
	pDC->LineTo( RIGHT_MAX, BOTTOM_MIN );

	pDC->MoveTo( LEFT_MAX, TOP_MIN );
	pDC->LineTo( LEFT_MAX, BOTTOM_MAX );

	pDC->MoveTo( RIGHT_MIN, TOP_MIN );
	pDC->LineTo( RIGHT_MIN, BOTTOM_MAX );

	pDC->SelectObject( pOldPen );
	pDC->SelectObject( pOldBrush );
	
	return TRUE;
}
