// LockableSplitter.cpp : implementation file
//

#include "stdafx.h"
#include "EkLockableSplitter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEkLockableSplitter

CEkLockableSplitter::CEkLockableSplitter()
{
	m_bLocked = FALSE;
}

CEkLockableSplitter::~CEkLockableSplitter()
{
}


BEGIN_MESSAGE_MAP(CEkLockableSplitter, CSplitterWnd)
	//{{AFX_MSG_MAP(CEkLockableSplitter)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_SETCURSOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEkLockableSplitter operations

void CEkLockableSplitter::SetLock( BOOL bLock )
{
	m_bLocked = bLock;
}

BOOL CEkLockableSplitter::GetLock() const
{
	return m_bLocked;
}

void CEkLockableSplitter::ToggleLock()
{
	m_bLocked = !m_bLocked;
}

/////////////////////////////////////////////////////////////////////////////
// CEkLockableSplitter message handlers

void CEkLockableSplitter::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if( m_bLocked )
	{
		// Bypass standard CSplitterWnd processing
		CWnd::OnLButtonDown(nFlags, point);
	}
	else
	{
		CSplitterWnd::OnLButtonDown(nFlags, point);
	}
}

void CEkLockableSplitter::OnMouseMove(UINT nFlags, CPoint point) 
{
	if( m_bLocked )
	{
		// Bypass standard CSplitterWnd processing
		CWnd::OnMouseMove(nFlags, point);
	}
	else
	{
		CSplitterWnd::OnMouseMove(nFlags, point);
	}
}

BOOL CEkLockableSplitter::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if( m_bLocked )
	{
		// Bypass standard CSplitterWnd processing
		return CWnd::OnSetCursor(pWnd, nHitTest, message);
	}
	else
	{
		return CSplitterWnd::OnSetCursor(pWnd, nHitTest, message);
	}
}
