#include "stdafx.h"

#include "EkMultiViewTemplate.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define new DEBUG_NEW

IMPLEMENT_DYNAMIC(CEkMultiViewTemplate, CMultiDocTemplate)

// Function defined in MainFrm.cpp
CFrameWnd* EkCreateNewWindow( CDocTemplate* pTemplate, CDocument* pDocument );

CEkMultiViewTemplate::CEkMultiViewTemplate(UINT nIDResource, CRuntimeClass* pDocClass,
	CRuntimeClass* pFrameClass, CRuntimeClass* pViewClass)
: CMultiDocTemplate(nIDResource, pDocClass, pFrameClass, pViewClass)
{ }

void CEkMultiViewTemplate::AddViewTemplate( CMultiDocTemplate* pViewTemplate )
{
	ASSERT( pViewTemplate != NULL );
	ASSERT_VALID( pViewTemplate );

	// Add the doc template to our list
	m_ViewList.AddTail( pViewTemplate );
}

CDocument* CEkMultiViewTemplate::OpenDocumentFile(
		LPCTSTR lpszPathName, BOOL bMakeVisible )
{
	// 1 - First, let CMultiDocTemplate do its standard thing
	CDocument* pDocument = CMultiDocTemplate::OpenDocumentFile(
		lpszPathName, bMakeVisible );

	if( pDocument != NULL )
	{
		// 2 - Now open each additional view in our list
		POSITION pos = m_ViewList.GetHeadPosition();
		while( pos != NULL )
		{
			CMultiDocTemplate* pViewTemplate = m_ViewList.GetNext( pos );
			EkCreateNewWindow( pViewTemplate, pDocument );
		}
	}

	return pDocument;
}

