// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DrawInDialog.h"
#include "DemoDlg.h"

#include "DrawDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog


CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	m_nX = 0;
	m_nY = 0;
	m_nShape = -1;
	//}}AFX_DATA_INIT
}


void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_DRAW_AREA, m_DrawArea);
	DDX_Control(pDX, IDC_SHAPE, m_cmbShape);
	DDX_Control(pDX, IDC_Y, m_edtY);
	DDX_Control(pDX, IDC_X, m_edtX);
	DDX_Text(pDX, IDC_X, m_nX);
	DDX_Text(pDX, IDC_Y, m_nY);
	DDX_CBIndex(pDX, IDC_SHAPE, m_nShape);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_PAINT()
	ON_CBN_SELCHANGE(IDC_SHAPE, OnSelchangeShape)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

void CDemoDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// 1 - Get placeholder coordinates
	CRect rect;		// Placeholder rectangle
	m_DrawArea.GetWindowRect( &rect );
	ScreenToClient( &rect );

	// 2 - Draw inside placeholder rectangle
	// Draw current shape
	CBrush brShape( RGB( 255, 0, 255 ) );
	CBrush* pOldBrush = dc.SelectObject( &brShape );

	int nShape = m_cmbShape.GetCurSel();

	switch( nShape )
	{
	default :
		ASSERT( FALSE );  // We should never get here !
		break;

	case CDrawDoc::SQUARE :
		dc.Rectangle( rect );
		break;

	case CDrawDoc::CIRCLE :
		dc.Ellipse( rect );
		break;
	}

	CPen pen( PS_SOLID, 2, RGB( 0, 0, 0 ) );
	CPen* pOldPen = dc.SelectObject( &pen );

	int x = ( rect.left + rect.right ) / 2;
	int y = ( rect.top + rect.bottom ) / 2;

	dc.MoveTo( x-3, y-3 );
	dc.LineTo( x+3, y+3 );

	dc.MoveTo( x-3, y+3 );
	dc.LineTo( x+3, y-3 );

	dc.SelectObject( pOldPen );
	dc.SelectObject( pOldBrush );
	
	// Do not call CDialog::OnPaint() for painting messages
}

void CDemoDlg::RedrawArea()
{
	// 1 - Get placeholder coordinates
	CRect rect;		// Placeholder rectangle
	m_DrawArea.GetWindowRect( &rect );
	ScreenToClient( &rect );

	// 2 - Force update of the drawing area
	InvalidateRect( rect );
	UpdateWindow();
}

void CDemoDlg::OnSelchangeShape() 
{
	RedrawArea();
}
