// DrawDoc.cpp : implementation of the CDrawDoc class
//

#include "stdafx.h"
#include "ManageButtons.h"

#include "DrawDoc.h"

#include "DemoPSheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc

IMPLEMENT_DYNCREATE(CDrawDoc, CDocument)

BEGIN_MESSAGE_MAP(CDrawDoc, CDocument)
	//{{AFX_MSG_MAP(CDrawDoc)
	ON_COMMAND(ID_DRAW_SQUARE, OnDrawSquare)
	ON_COMMAND(ID_DRAW_CIRCLE, OnDrawCircle)
	ON_UPDATE_COMMAND_UI(ID_DRAW_SQUARE, OnUpdateDrawSquare)
	ON_UPDATE_COMMAND_UI(ID_DRAW_CIRCLE, OnUpdateDrawCircle)
	ON_COMMAND(ID_DEMO_PSHEET, OnDemoPSheet)
	ON_COMMAND(ID_DEMO_CHANGE_CAPTIONS, OnDemoChangeCaptions)
	ON_UPDATE_COMMAND_UI(ID_DEMO_CHANGE_CAPTIONS, OnUpdateDemoChangeCaptions)
	ON_COMMAND(ID_DEMO_HIDE_BUTTONS, OnDemoHideButtons)
	ON_UPDATE_COMMAND_UI(ID_DEMO_HIDE_BUTTONS, OnUpdateDemoHideButtons)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc construction/destruction

CDrawDoc::CDrawDoc()
{
	m_point = CPoint( 30, 30 );
	m_shape = SQUARE;

	m_bChangeCaptions = TRUE;
}

CDrawDoc::~CDrawDoc()
{
}

BOOL CDrawDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc serialization

void CDrawDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar << m_point << (DWORD) m_shape;
	}
	else
	{
		ar >> m_point >> (DWORD&) m_shape;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc diagnostics

#ifdef _DEBUG
void CDrawDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDrawDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc commands

void CDrawDoc::OnDrawSquare() 
{
	m_shape = SQUARE;
	UpdateAllViews( NULL );
	SetModifiedFlag( TRUE );
}

void CDrawDoc::OnDrawCircle() 
{
	m_shape = CIRCLE;
	UpdateAllViews( NULL );
	SetModifiedFlag( TRUE );
}

void CDrawDoc::OnUpdateDrawSquare(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_shape == SQUARE );
}

void CDrawDoc::OnUpdateDrawCircle(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_shape == CIRCLE );
}

void CDrawDoc::OnDemoPSheet() 
{
	// 1 - Create the property sheet object
	CDemoPSheet psheet;
	psheet.m_bChangeCaptions = m_bChangeCaptions;


	// 2 - Initialize the pages' member variables
	psheet.m_CoordsPPage.m_nX = m_point.x;
	psheet.m_CoordsPPage.m_nY = m_point.y;
	psheet.m_ShapePPage.m_nShape = m_shape;

	// 3 - Show the property sheet to the user
	if( psheet.DoModal() == IDOK )
	{
		// 4 - Read the new values from the
		// pages' member variables
		m_point.x = psheet.m_CoordsPPage.m_nX;
		m_point.y = psheet.m_CoordsPPage.m_nY;
		m_shape = static_cast< SHAPE >( psheet.m_ShapePPage.m_nShape );

		SetModifiedFlag( TRUE );
		UpdateAllViews( NULL );
	}
}


void CDrawDoc::OnDemoChangeCaptions() 
{
	m_bChangeCaptions = TRUE;
}

void CDrawDoc::OnUpdateDemoChangeCaptions(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_bChangeCaptions );
}

void CDrawDoc::OnDemoHideButtons() 
{
	m_bChangeCaptions = FALSE;
}

void CDrawDoc::OnUpdateDemoHideButtons(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( !m_bChangeCaptions );
}
