// DrawDoc.cpp : implementation of the CDrawDoc class
//

#include "stdafx.h"
#include "PropertySheetInMiniFrame.h"

#include "DrawDoc.h"

#include "PSheetMiniFrameWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc

IMPLEMENT_DYNCREATE(CDrawDoc, CDocument)

BEGIN_MESSAGE_MAP(CDrawDoc, CDocument)
	//{{AFX_MSG_MAP(CDrawDoc)
	ON_COMMAND(ID_DRAW_SQUARE, OnDrawSquare)
	ON_COMMAND(ID_DRAW_CIRCLE, OnDrawCircle)
	ON_UPDATE_COMMAND_UI(ID_DRAW_SQUARE, OnUpdateDrawSquare)
	ON_UPDATE_COMMAND_UI(ID_DRAW_CIRCLE, OnUpdateDrawCircle)
	ON_COMMAND(ID_DEMO_PSHEET, OnDemoPSheet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc construction/destruction

CDrawDoc::CDrawDoc()
{
	m_point = CPoint( 30, 30 );
	m_shape = SQUARE;
}

CDrawDoc::~CDrawDoc()
{
}

BOOL CDrawDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc serialization

void CDrawDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar << m_point << (DWORD) m_shape;
	}
	else
	{
		ar >> m_point >> (DWORD&) m_shape;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc diagnostics

#ifdef _DEBUG
void CDrawDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDrawDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc commands

void CDrawDoc::OnDrawSquare() 
{
	m_shape = SQUARE;
	UpdateAllViews( NULL );
	SetModifiedFlag( TRUE );
}

void CDrawDoc::OnDrawCircle() 
{
	m_shape = CIRCLE;
	UpdateAllViews( NULL );
	SetModifiedFlag( TRUE );
}

void CDrawDoc::OnUpdateDrawSquare(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_shape == SQUARE );
}

void CDrawDoc::OnUpdateDrawCircle(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_shape == CIRCLE );
}

void CDrawDoc::OnDemoPSheet() 
{
	// 1 - Create the mini-frame window C++ object
	// (C++ object is deleted when window is destroyed)
	CPSheetMiniFrameWnd* pMiniFrameWnd = new CPSheetMiniFrameWnd;

	// 2 - Initialize the pages' member variables
	pMiniFrameWnd->m_psheet.m_CoordsPPage.m_nX = m_point.x;
	pMiniFrameWnd->m_psheet.m_CoordsPPage.m_nY = m_point.y;
	pMiniFrameWnd->m_psheet.m_ShapePPage.m_nShape = m_shape;

	// 3 - Create the mini-frame Windows window and show it
	// to the user
	pMiniFrameWnd->Create(	NULL, _T( "Mini Frame Window" ),
 							WS_POPUP|WS_CAPTION|WS_SYSMENU,
							CRect( 0, 0, 0, 0 ),
							AfxGetMainWnd() );
}
