// SplitFrame2.cpp : implementation file
//

#include "stdafx.h"
#include "PropertySheetInSplitter.h"
#include "SplitFrame2.h"

#include "DrawDoc.h"
#include "DrawView.h"
#include "PSheetFormView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSplitFrame2

IMPLEMENT_DYNCREATE(CSplitFrame2, CMDIChildWnd)

CSplitFrame2::CSplitFrame2()
{
}

CSplitFrame2::~CSplitFrame2()
{
}

BOOL CSplitFrame2::OnCreateClient(LPCREATESTRUCT /*lpcs*/, CCreateContext* pContext)
{
	CRect rect;
	GetClientRect( &rect );
	CSize size = rect.Size();
	size.cx /= 2;		// Initial column size

	// 1 - Create static splitter
	if( !m_wndSplitter.CreateStatic( this, 1, 2 ) )	// 1 row, 2 cols
	{
		TRACE0( "Failed to create static splitter\n" );
		return FALSE;
	}

	// 2 - Create left view
	if( !m_wndSplitter.CreateView( 0, 0,			// row 0, col 0
							RUNTIME_CLASS( CDrawView ), 
							size, pContext ) )
	{
		TRACE0( "Failed to create left view\n" );
		return FALSE;
	}

	// 3 - Create right view
	if( !m_wndSplitter.CreateView( 0, 1,			// row 0, col 1
							RUNTIME_CLASS( CPSheetFormView ), 
							size, pContext ) )
	{
		TRACE0( "Failed to create right view\n" );
		return FALSE;
	}

	return TRUE;
}


BEGIN_MESSAGE_MAP(CSplitFrame2, CMDIChildWnd)
	//{{AFX_MSG_MAP(CSplitFrame2)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSplitFrame2 message handlers
