// DrawDoc.cpp : implementation of the CDrawDoc class
//

#include "stdafx.h"
#include "ComboBoxInToolbar.h"

#include "DrawDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc

IMPLEMENT_DYNCREATE(CDrawDoc, CDocument)

BEGIN_MESSAGE_MAP(CDrawDoc, CDocument)
	//{{AFX_MSG_MAP(CDrawDoc)
	ON_COMMAND(ID_DRAW_SQUARE, OnDrawSquare)
	ON_COMMAND(ID_DRAW_CIRCLE, OnDrawCircle)
	ON_UPDATE_COMMAND_UI(ID_DRAW_SQUARE, OnUpdateDrawSquare)
	ON_UPDATE_COMMAND_UI(ID_DRAW_CIRCLE, OnUpdateDrawCircle)

	// Toolbar combo-box
	ON_COMMAND(IDC_SHAPES_COMBO_BOX, OnSelChangeTBComboBox) 
	ON_UPDATE_COMMAND_UI(IDC_SHAPES_COMBO_BOX, OnUpdateTBComboBox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc construction/destruction

CDrawDoc::CDrawDoc()
{
	m_point = CPoint( 30, 30 );
	m_shape = SQUARE;
}

CDrawDoc::~CDrawDoc()
{
}

BOOL CDrawDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc serialization

void CDrawDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar << m_point << (DWORD) m_shape;
	}
	else
	{
		ar >> m_point >> (DWORD&) m_shape;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc diagnostics

#ifdef _DEBUG
void CDrawDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDrawDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDrawDoc commands

void CDrawDoc::OnDrawSquare() 
{
	m_shape = SQUARE;
	UpdateAllViews( NULL );
	SetModifiedFlag( TRUE );
}

void CDrawDoc::OnDrawCircle() 
{
	m_shape = CIRCLE;
	UpdateAllViews( NULL );
	SetModifiedFlag( TRUE );
}

void CDrawDoc::OnUpdateDrawSquare(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_shape == SQUARE );
}

void CDrawDoc::OnUpdateDrawCircle(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck( m_shape == CIRCLE );
}

void CDrawDoc::OnSelChangeTBComboBox() 
{
	// Find combo-box from LPARAM
	HWND hWnd = reinterpret_cast<HWND>( AfxGetApp()->m_msgCur.lParam );

	ASSERT( ::IsWindow( hWnd ) );

	CComboBox* pCB = static_cast<CComboBox*>( CWnd::FromHandle( hWnd ) );

	ASSERT_VALID( pCB );
	ASSERT( pCB->GetDlgCtrlID() == IDC_SHAPES_COMBO_BOX );

	// Update document
	m_shape = static_cast< SHAPE >( pCB->GetCurSel() );
	UpdateAllViews( NULL );
	SetModifiedFlag( TRUE );
}

void CDrawDoc::OnUpdateTBComboBox(CCmdUI* pCmdUI) 
{
	// Find combo-box from pCmdUI
	CComboBox* pCB = static_cast<CComboBox*>( pCmdUI->m_pOther );

	ASSERT( ::IsWindow( pCB->GetSafeHwnd() ) );
	ASSERT( pCB->GetDlgCtrlID() == IDC_SHAPES_COMBO_BOX );

	// Test to prevent flicker
	if( m_shape != pCB->GetCurSel() && !pCB->GetDroppedState() )
	{
		pCB->SetCurSel( m_shape );
	}
}
