// DrawDoc.h : interface of the CDrawDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CDrawDoc : public CDocument
{
protected: // create from serialization only
	CDrawDoc();
	DECLARE_DYNCREATE(CDrawDoc)

// Attributes
public:
	CPoint m_point;
	enum SHAPE { SQUARE = 0, CIRCLE = 1 } m_shape;
	COLORREF m_crColor;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDrawDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDrawDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	static COLORREF GetColorRef( UINT nID );
	static int s_ColorMap[];

// Generated message map functions
protected:
	//{{AFX_MSG(CDrawDoc)
	afx_msg void OnDrawSquare();
	afx_msg void OnDrawCircle();
	afx_msg void OnUpdateDrawSquare(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDrawCircle(CCmdUI* pCmdUI);
	//}}AFX_MSG

	// Color handling	
	afx_msg void OnColor(UINT nID);
	afx_msg void OnUpdateColor(CCmdUI* pCmdUI);
	
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
