// DrawView.cpp : implementation of the CDrawView class
//

#include "stdafx.h"
#include "ContextMenu.h"

#include "DrawDoc.h"
#include "DrawView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDrawView

IMPLEMENT_DYNCREATE(CDrawView, CView)

BEGIN_MESSAGE_MAP(CDrawView, CView)
	//{{AFX_MSG_MAP(CDrawView)
	ON_WM_LBUTTONDOWN()
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawView construction/destruction

CDrawView::CDrawView()
{
	// TODO: add construction code here
}

CDrawView::~CDrawView()
{
}

BOOL CDrawView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDrawView drawing

void CDrawView::OnDraw(CDC* pDC)
{
	CDrawDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CBrush brush( pDoc->m_crColor );
	CBrush* pOldBrush = pDC->SelectObject( &brush );

	CRect rect( pDoc->m_point.x-20, pDoc->m_point.y-20,
				pDoc->m_point.x+20, pDoc->m_point.y+20 );

	switch( pDoc->m_shape )
	{
	default :
		ASSERT( FALSE );  // We should never get here !
		break;

	case CDrawDoc::SQUARE :
		pDC->Rectangle( rect );
		break;

	case CDrawDoc::CIRCLE :
		pDC->Ellipse( rect );
		break;
	}

	CPen pen( PS_SOLID, 2, RGB( 0, 0, 0 ) );
	CPen* pOldPen = pDC->SelectObject( &pen );

	pDC->MoveTo( pDoc->m_point.x-3, pDoc->m_point.y-3 );
	pDC->LineTo( pDoc->m_point.x+3, pDoc->m_point.y+3 );

	pDC->MoveTo( pDoc->m_point.x-3, pDoc->m_point.y+3 );
	pDC->LineTo( pDoc->m_point.x+3, pDoc->m_point.y-3 );

	pDC->SelectObject( pOldPen );
	pDC->SelectObject( pOldBrush );
}

/////////////////////////////////////////////////////////////////////////////
// CDrawView printing

BOOL CDrawView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDrawView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDrawView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDrawView diagnostics

#ifdef _DEBUG
void CDrawView::AssertValid() const
{
	CView::AssertValid();
}

void CDrawView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDrawDoc* CDrawView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDrawDoc)));
	return (CDrawDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDrawView message handlers

void CDrawView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDrawDoc* pDoc = GetDocument();
	pDoc->m_point = point;
	pDoc->UpdateAllViews( NULL );
	pDoc->SetModifiedFlag( TRUE );
	
	CView::OnLButtonDown(nFlags, point);
}

void CDrawView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// 1 - Adjust point if needed (for keyboard context menu)
	if( point.x == -1 && point.y == -1 )
	{
		CRect rect;
		GetClientRect( &rect );
		point = rect.TopLeft();
		point.Offset( 5, 5 );
		ClientToScreen( &point );
	}

	// 2 - Load top-level menu from resource
	CMenu mnuTop;
	mnuTop.LoadMenu( IDR_COLOR_POPUP );

	// 3 - Get popup menu from first sub-menu
	CMenu* pPopup = mnuTop.GetSubMenu( 0 );
	ASSERT_VALID( pPopup );

	// Checked state for popup menu items is automatically
	// managed by standard MFC UPDATE_COMMAND_UI mechanism!

	// 4 - Display popup menu
	pPopup->TrackPopupMenu(	TPM_LEFTALIGN | TPM_LEFTBUTTON,
							point.x, point.y,
							AfxGetMainWnd(), NULL );

	// Popup menu commands are automatically handled
	// by standard MFC command-routing mechanism!
}
