// DrawDoc.h : interface of the CDrawDoc class
//
/////////////////////////////////////////////////////////////////////////////

#include "Shape.h"
#include <afxtempl.h>

class CDrawDoc : public CDocument
{
protected: // create from serialization only
	CDrawDoc();
	DECLARE_DYNCREATE(CDrawDoc)

// Attributes
public:
	CTypedPtrArray< CObArray, CShape* > m_Shapes;
	COLORREF m_crColor;
	CShape::SHAPE m_shape;

// Operations
public:
	void AddShape( CPoint point );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDrawDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDrawDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CDrawDoc)
	afx_msg void OnDrawSquare();
	afx_msg void OnDrawCircle();
	afx_msg void OnUpdateDrawSquare(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDrawCircle(CCmdUI* pCmdUI);
	//}}AFX_MSG
	
	// Color handling
	afx_msg void OnColor(UINT nID);
	afx_msg void OnUpdateColor(CCmdUI* pCmdUI);

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
